// field2.cpp
//
// Priklad pretizeneho prirazovaciho operatoru 

// Vzhledem k rozdilum v chovani prekladacu
// zde nekontrolujeme, zda se alokace podarila, stejne jako
// v predchozich verzich

#ifdef _WIN32
	#include <tchar.h>
	#include <conio.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <iostream>
using namespace std;

class pole {
	int* p;
public:
	enum { delka = 10 };
	explicit pole(int d = 0);
	pole(pole&);
	int& operator[](int);
	~pole() { delete p; }
	pole& operator=(pole& p);
};

pole& pole::operator=(pole& P)   // Pretizeny operator =
{
	for (int i = 0; i < delka; i++)
		p[i] = P.p[i];
	return *this;	// Zde vraci odkaz na levy operand
}

pole::pole(int d)
{
	p = new int[delka];
	for (int i = 0; i < delka; i++)
		p[i] = d;
}

pole::pole(pole& P)
{
	p = new int[delka];
	for (int i = 0; i < delka; i++)
		p[i] = P.p[i];
}

int& pole::operator [](int index)
{
	return p[index];
}

void my_getch();

int main()
{
	pole P(0);
	for (int i = 0; i < pole::delka; i++)
		P[i] = 10;
	pole Q(0);
	Q = P;	// Pouzijeme pretizeny prirazovaci operator
				// .....
	cout << "\n  There is no output in this example.\n";
	my_getch();
	return 0;
}
//---------------------------------------------------------------------------
void my_getch()
{
#ifdef _WIN32
	_getch();
#else
	cout << endl;
#endif
}
//---------------------------------------------------------------------------
